#include <wiringPi.h>
#include <stdio.h>
#include <stdlib.h>
#include "gpio_pwm.h"

// 定义 PWM 引脚的 WiringPi 编号
#define PWM_PIN_SPEED 21
#define PWM_PIN_CHANGE 2

const int gpioWPi[] = {5, 6, 7, 10, 16, 20, 22, 23, 24, 25, 26, 27};

void pin_init()//初始化引脚
{
    int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
    // 设置所有GPIO为输出模式
    for(int i = 0; i < gpioCount; i++) {
        pinMode(gpioWPi[i], OUTPUT);
        digitalWrite(gpioWPi[i], LOW);  // 初始化所有引脚为低电平
    }
    
}

void pin_all_default()//全部至低电平
{
	int gpioCount = sizeof(gpioWPi) / sizeof(gpioWPi[0]);
	for (int i=0;i<gpioCount;i++)
	{
		digitalWrite(gpioWPi[i], LOW);
	}
}

void pin_value(int pin,int value)
{
	
	if(value==1){
		digitalWrite(pin, HIGH);
		printf("pin:%d,%d\n",pin,HIGH);
	}else if(value==0){
		digitalWrite(pin, LOW);
		printf("pin:%d,%d\n",pin,LOW);
	}
	
}

void pwm_speed() {

    int pwm_clock = 24000000 / (50 * 1000);// 定义 PWM 频率为 50Hz
    pinMode(PWM_PIN_SPEED,PWM_OUTPUT);
    pinMode(PWM_PIN_CHANGE,PWM_OUTPUT);

    pwmSetClock(PWM_PIN_SPEED,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_SPEED,1000);//占空比范围
    pwmSetClock(PWM_PIN_CHANGE,pwm_clock);//=19200*1000/(hz*2000)
    pwmSetRange(PWM_PIN_CHANGE,1000);//占空比范围

	pwmWrite(PWM_PIN_SPEED,75);
    pwmWrite(PWM_PIN_CHANGE,70);
    
}

void midde_pwm()//中间pwm值
{
    pwmWrite(PWM_PIN_SPEED,75);
    pwmWrite(PWM_PIN_CHANGE,70);
}

void mode_1_flont(unsigned char gval)
{

    if(gval<50)
	{
		pwmWrite(PWM_PIN_SPEED,75);
	}
	if(50<=gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,72);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,72);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,70);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,70);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,69);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,68);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,68);
        
	}
	if(100<gval&&gval<=110)
	{
		pwmWrite(PWM_PIN_SPEED,66);  
	}
	if(110<gval&&gval<=120)
	{
		pwmWrite(PWM_PIN_SPEED,65); 
	}
	if(120<gval&&gval<=130)
	{
		pwmWrite(PWM_PIN_SPEED,64); 
	}
	if(130<gval&&gval<=140)
	{
		pwmWrite(PWM_PIN_SPEED,62); 
	}
	if(140<gval&&gval<=150)
	{
		pwmWrite(PWM_PIN_SPEED,60); 
	}
	if(150<gval&&gval<=160)
	{
		pwmWrite(PWM_PIN_SPEED,59); 
	}
	if(160<gval&&gval<=170)
	{
		pwmWrite(PWM_PIN_SPEED,58); 
	}
	if(170<gval&&gval<=180)
	{
		pwmWrite(PWM_PIN_SPEED,57); 
	}
	if(180<gval&&gval<=190)
	{
		pwmWrite(PWM_PIN_SPEED,56); 
	}
	if(190<gval&&gval<=200)
	{
		pwmWrite(PWM_PIN_SPEED,55); 
	}
}

void mode_2_back(unsigned char gval)
{

   if(gval<50)
	{
		pwmWrite(PWM_PIN_SPEED,75);
	}
	if(50<=gval&&gval<=55)
	{
		pwmWrite(PWM_PIN_SPEED,76);
	}
	if(55<gval&&gval<=60)
	{
		pwmWrite(PWM_PIN_SPEED,77);
	}
	if(60<gval&&gval<=65)
	{
		pwmWrite(PWM_PIN_SPEED,77);
	}
	if(65<gval&&gval<=70)
	{
		pwmWrite(PWM_PIN_SPEED,78);
	}
	if(70<gval&&gval<=75)
	{
		pwmWrite(PWM_PIN_SPEED,78);
	}
	if(75<gval&&gval<=90)
	{
		pwmWrite(PWM_PIN_SPEED,79);
	}
	if(90<gval&&gval<=100)
	{
		pwmWrite(PWM_PIN_SPEED,80);
        
	}
		if(110<gval&&gval<=120)
	{
		pwmWrite(PWM_PIN_SPEED,81); 
	}
	if(120<gval&&gval<=130)
	{
		pwmWrite(PWM_PIN_SPEED,82); 
	}
	if(130<gval&&gval<=140)
	{
		pwmWrite(PWM_PIN_SPEED,83); 
	}
	if(140<gval&&gval<=150)
	{
		pwmWrite(PWM_PIN_SPEED,84); 
	}
	if(150<gval&&gval<=160)
	{
		pwmWrite(PWM_PIN_SPEED,85); 
	}
	if(160<gval&&gval<=170)
	{
		pwmWrite(PWM_PIN_SPEED,86); 
	}
	if(170<gval&&gval<=180)
	{
		pwmWrite(PWM_PIN_SPEED,87); 
	}
	if(180<gval&&gval<=190)
	{
		pwmWrite(PWM_PIN_SPEED,88); 
	}
	if(190<gval&&gval<=200)
	{
		pwmWrite(PWM_PIN_SPEED,89); 
	}
}

void mode_3_left(unsigned char gval)
{
    if(gval<45)
	{
	pwmWrite(PWM_PIN_CHANGE,70);
	}
	if(gval>=45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,80);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,83);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,85);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,90);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,95);
	}
	if(gval>75&&gval<=81)
	{
		pwmWrite(PWM_PIN_CHANGE,98);
	}
	if(gval>81&&gval<=87)
	{
		pwmWrite(PWM_PIN_CHANGE,100);
	}
	if(gval>87&&gval<=93)
	{
		pwmWrite(PWM_PIN_CHANGE,102);
	}
	if(gval>93&&gval<=100)
	{
		pwmWrite(PWM_PIN_CHANGE,105);
	}
}

void mode_4_right(unsigned char gval)
{
    if(gval<45)
	{
		pwmWrite(PWM_PIN_CHANGE,70);
	}
	if(gval>=45&&gval<=51)
	{
		pwmWrite(PWM_PIN_CHANGE,60);
	}
	if(gval>51&&gval<=57)
	{
		pwmWrite(PWM_PIN_CHANGE,57);
	}
	if(gval>57&&gval<=63)
	{
		pwmWrite(PWM_PIN_CHANGE,54);
	}
	if(gval>63&&gval<=69)
	{
		pwmWrite(PWM_PIN_CHANGE,50);
	}
	if(gval>69&&gval<=75)
	{
		pwmWrite(PWM_PIN_CHANGE,45);
	}
	if(gval>75&&gval<=81)
	{
		pwmWrite(PWM_PIN_CHANGE,42);
	}
	if(gval>81&&gval<=87)
	{
		pwmWrite(PWM_PIN_CHANGE,40);
	}
	if(gval>87&&gval<=93)
	{
		pwmWrite(PWM_PIN_CHANGE,38);
	}
	if(gval>93&&gval<=100)
	{
		pwmWrite(PWM_PIN_CHANGE,35);
	}
}

void speed_change(unsigned char *buf)//速度和转向引脚数值处理函数
{
    unsigned char mode=buf[1];
    unsigned char val=buf[2];

    switch(mode)
    {
        case 1:			
		mode_1_flont(val);					 
			break;
		case 2:	
			mode_2_back(val);
			break;
		case 3:
			mode_3_left(val);
			break;
		case 4:
			mode_4_right(val);
			break; 
        default:
			break;
    }
    
}
