#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include <mosquitto.h>
#include <cjson/cJSON.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ifaddrs.h>
#include <wiringPi.h>
#include "gpio_pwm.h"
#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "delay.h"
#include "opensh.h"

char buffer[30]; // 用于存储文件内容
uint8_t AppExit_pin_pwm=0;//判断坦克或者车的退出

void *AppExit(void *arg)//出现意外自动停止
{ 
  
    while(1)
    {    
        Delay_Ms(0,100);
        gPwmCount++;
        gmessage_2_index++;
        if(gPwmCount>=5)
        {
            if(AppExit_pin_pwm==1)//车异常问题处理
            {
                midde_pwm();
                pin_all_default();
            }
            if(AppExit_pin_pwm==2)//坦克异常问题处理
            {
                midde_pwm();
                pin_all_default();
                digitalWrite(2, LOW);
                digitalWrite(21, LOW);

            } 
            gPwmCount=6;
        } 
        if(gmessage_2_index>=150)//计时15s，15s才能远程刷新一次
        {
            gmessage_2_index=160;
        }

    }
    
    return NULL; 
}

void *Mqttbeat(void *arg)
{ 
    printf("Mqttbeat start\n");
    //refresh_cam();//刷新cam
    Delay_Ms(15,0);
   
    while(1)
    {
        ipaddr();//获取ip
        Delay_Ms(3,0);
        mqtt_wirte();//心跳，3s一个        
    }

    return NULL;
}

void *opensh(void *arg)
{ 
    Delay_Ms(5,0);
    printf("open cam\n");
    opencamsh();//10s后打开游览器并且进入网址 
   return NULL; 
}

void *Mqtt_onnect(void *arg)//mqtt异常处理，断开自动重连，简单粗暴
{
    Delay_Ms(5,0);
    mqtt_init();//mqtt初始化
    mqtt_create(mosq);//创建mqtt客户端
    while(1)
    {
    mqtt_create(mosq);//创建mqtt客户端     
    mqtt_cycle(mosq); //进入mqtt死循环，异常退出继续执行while
    }
    mqtt_clean(mosq);
    return NULL;
}

char *device_inspect()//读出文件函数
{
    FILE *file;
    while (1) {
        file = fopen(filename, "r"); // 以只读模式打开文件

        if (file == NULL) 
        {
            printf("文件 %s 打开失败，等待中...\n", filename);
        } 
        else 
        {
            // 尝试读取文件内容
            if (fgets(buffer, sizeof(buffer), file) != NULL) 
            {
                // 如果文件内容不为空
                fclose(file);
                printf("读取到文件内容: %s\n", buffer);
                return  buffer;
            } 
            else 
            {
                printf("文件为空，等待中...\n");
            }
            fclose(file);
        }

        Delay_Ms(1,0); // 等待1秒后再次检查
    }
}

int main(int argc, char *argv[]) {

    if (wiringPiSetup() == -1) {
        printf("WiringPi setup failed!\n");
        return 1;
        }
    const char *readbuf=device_inspect();
    
    //将第3个和第4个字符提取出来
    char *sub_str=malloc(3);
    sub_str[0]=readbuf[2];
    sub_str[1]=readbuf[3];
    sub_str[2]='\0';
    printf("开始初始化了");
     if(strcmp(sub_str,"02")==0){//坦克的编码
        pin_init();
        pinMode(2, OUTPUT);
		pinMode(21, OUTPUT);
        digitalWrite(2, LOW);
        digitalWrite(21, LOW);
        AppExit_pin_pwm=1;//坦克的异常停止值
        free(sub_str);
    }else if(strcmp(sub_str,"01")==0){//车的编码
    
        pwm_speed(); //pwm初始化，车为停止
        pin_init();
        AppExit_pin_pwm=2;//车的异常停止值
        free(sub_str);
    }
    Delay_Ms(20,0);
    TOPIC=malloc(24);
    TOPIC2=malloc(24);
    TOPIC3= malloc(16);

    sprintf(TOPIC2,"dev2app/%s",readbuf);
    sprintf(TOPIC,"app2dev/%s",readbuf);
    sprintf(TOPIC3,"%s",readbuf);
    printf("1:%s,2:%s,3:%s\n",TOPIC,TOPIC2,TOPIC3);
    system("pkill  chromium");
    
    gStart=time(NULL);//开始时间戳
   

    ipaddr();//获取ip

    thread_start(AppExit,Mqttbeat,opensh,Mqtt_onnect);//开启线程
    
    thread_end();

    return EXIT_SUCCESS;
}